{{- if .Values.cronJobResetDB -}}
apiVersion: batch/v1
kind: CronJob
metadata:
  name: restore-db-{{ .Release.Name }}
  namespace: {{ .Release.Namespace }}
spec:
  suspend: true
  schedule: "0 0 * * *"
  successfulJobsHistoryLimit: 2
  failedJobsHistoryLimit: 1
  jobTemplate:
    spec:
      template:
        spec:
          containers:
          - name: restore-db-{{ .Release.Name }}
            image: {{ .Values.cronJobResetDBImage }}
            imagePullPolicy: IfNotPresent
            env:
              - name: APP_DBNAME
                value: spa_service_{{ .Values.shortNameEnv | lower }}
              - name: PGHOST
                value: postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local
              - name: PGUSER
                value: postgres
              - name: PGPASSWORD
                valueFrom:
                  secretKeyRef:
                    name: postgresql-secrets
                    key: POSTGRES_DB_PASSWORD
            command:
            - /bin/sh
            - -c
            - >
              echo Waiting for DB to be ready...;
              while ! pg_isready >dev/null; do sleep 3; done;
              echo DB is ready and accepting conncetions;
              echo ------------------------------------------------------------------------;
              echo Dropping active connections to database ${APP_DBNAME};
              echo psql -c "SELECT pg_terminate_backend(pg_stat_activity.pid) FROM pg_stat_activity WHERE pg_stat_activity.datname =  '${APP_DBNAME}' AND pid <> pg_backend_pid()";
              echo ------------------------------------------------------------------------;
              echo Start restoring DB: ${APP_DBNAME} ...;
              pg_restore --host 'postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local' --port 5432 --username "postgres" --dbname "${APP_DBNAME}" --no-password --clean --verbose "/mnt/db-backups/${APP_DBNAME}";
              echo Restoring DB done;
              echo ------------------------------------------------------------------------;
            volumeMounts:
            - mountPath: "/mnt/db-backups"
              name: backup-volume
          volumes:
            - name: backup-volume
              persistentVolumeClaim:
                claimName: database-backups
          restartPolicy: Never
{{- end -}}